#include <Wire.h>
#include "pitches.h"


//__________________________________________________________________
//______________Global Variables____________________________________
//__________________________________________________________________

const int DS1307 = 0x68;                                                            // Address of DS1307 see data sheets

int Reed1 = 2;                                                                      //pin for reed contact nummero 1
int Reed2 = 4;
int Reed3 = 6;
int Reed4 = 7;
int Reed5 = 8;
int Reed6 = 9;
int Reed7 = 10;
int Reed8 = 11;
int Reed9 = 12;
int MicroSwitch = 13;
int Button = A0;
int led = 3;                                                                        // the pin that the LED is attached to
int speaker = 5;
int brightness = 255;                                                               // how bright the LED is used for waking
int brightnessLamp = 0;                                                             // how bright the LED is


int Reed1_Loc = 0;                                                                  //location of reed pin state in array
int Reed2_Loc = 1;
int Reed3_Loc = 2;
int Reed4_Loc = 3;
int Reed5_Loc = 0;
int Reed6_Loc = 1;
int Reed7_Loc = 2;
int Reed8_Loc = 3;
int Reed9_Loc = 4;

int SetHour[4];                                                                   //Array for set Hours
int SetMinute[5];                                                                 //array for set Minutes
int SwitchState;                                                                  //Current state of switch
int ButtonState;
    
int Target_Minute = 0;                                                            //Set time when to wake
int Target_Hour = 0;
int Alarm_Minute;                                                                 //Calculated time when to begin waking
int Alarm_Hour;

byte Current_Minute;
byte Current_Hour;

boolean alarmactive = false;
boolean waking = false;
boolean blinktime = false;
int WakeTime = 15;                                                                 //How many minutes before alarm to start turning on the light

unsigned long previousMillis = 0;                                                  //variable for avoiding delay function
const long first_interval = 10000;                                                 //Length of first interval steps in ms
const long first_interval_steps = 30;                                              //number of interval steps for slow beginning, SET IT HERE

const long second_interval = ((WakeTime*60000)-(first_interval_steps*first_interval))/(255-first_interval_steps);    
  
int fis=first_interval_steps;                                                       


int twelve[4] = {1,1,0,1};
int one[4] = {1,0,1,0};
int two[4] = {0,1,0,1};
int three[4] = {1,0,1,1};
int four[4] = {0,1,1,1};
int five[4] = {1,1,1,1};
int six[4]= {1,1,1,0};
int seven[4] = {1,1,0,0};
int eight[4] = {1,0,0,0};
int nine[4] = {0,0,0,1};
int ten[4] = {0,0,1,1};
int eleven[4] = {0,1,1,0};

int sixty[5] = {1,0,1,1,0};
int sixty2[5] = {1,0,1,1,1};
int zero_f[5] = {1,1,1,0,1};
int ten_z[5] = {1,1,0,0,1};
int ten_f[5] = {1,0,0,0,1};
int ten_f2[5] = {1,0,0,1,1};
int ten_f3[5] = {0,0,0,1,1};
int twenty_z[5] = {0,0,0,1,1};
int twenty_f[5] = {0,0,1,1,1};
int thirty_z[5] = {0,1,1,1,1};
int thirty_f[5] = {1,1,1,1,0};
int forty_z[5] = {1,1,1,0,1};
int forty_f[5] = {0,1,0,1,0};
int forty_f2[5] = {0,1,1,1,0};
int fifty_z[5] = {1,0,1,0,1};
int fifty_z2[5] = {0,0,1,0,1};
int fifty_f[5] = {1,1,0,1,1};
int notime[5] = {1,1,1,1,1};

byte second = 0;                                                                      //values for RTC
byte weekday = 0;
byte monthday = 0;
byte month = 0;
byte year = 0;

int melody[] = {                                                                       // notes in the melody
  NOTE_D4, NOTE_G4,NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_G4, NOTE_FS4, NOTE_E4, NOTE_FS4, NOTE_G4, 0,
  NOTE_D4, NOTE_G4,NOTE_FS4, NOTE_G4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_G4, NOTE_FS4, NOTE_E4, NOTE_FS4, NOTE_G4,0,
  NOTE_B4, NOTE_B4, NOTE_B4, NOTE_B4, 0,  NOTE_B4, NOTE_B4, NOTE_B4,0, NOTE_B4, NOTE_A4, NOTE_G4, NOTE_A4, NOTE_B4,0,
  NOTE_B4,NOTE_B4, NOTE_C4, NOTE_B4, NOTE_A4, NOTE_E4, NOTE_A4, NOTE_G4, NOTE_FS4, NOTE_E4, NOTE_FS4, NOTE_G4
};         
                             
int noteDurations[] = {                                                               //// note durations: 4 = quarter note, 8 = eighth note, etc.:
  4, 4, 4, 4, 4, 4, 2, 4, 4, 4, 4, 2, 2,
  4, 4, 4, 4, 4, 4, 2, 4, 4, 4, 4, 2,2,
  2, 2, 4, 2,4,  2, 4, 2,4, 4, 4, 4, 4, 2,2,
  4, 4, 4, 4, 4, 4, 2, 4, 4, 4, 4, 2
};

//__________________________________________________________________
//______________setup_______________________________________________
//__________________________________________________________________

void setup() {
  Wire.begin();
  
  pinMode(Reed1, INPUT_PULLUP);                                                     //configure Reed1 Pin as input and enable internal pullup Resistor       
  pinMode(Reed2, INPUT_PULLUP);
  pinMode(Reed3, INPUT_PULLUP);
  pinMode(Reed4, INPUT_PULLUP);
  pinMode(Reed5, INPUT_PULLUP);
  pinMode(Reed6, INPUT_PULLUP);
  pinMode(Reed7, INPUT_PULLUP);
  pinMode(Reed8, INPUT_PULLUP);
  pinMode(Reed9, INPUT_PULLUP);  
  pinMode(MicroSwitch, INPUT_PULLUP);  
  pinMode(Button, INPUT_PULLUP);  
  pinMode(led, INPUT);

  analogWrite(led, 0);
}


//__________________________________________________________________
//______________loop________________________________________________
//__________________________________________________________________

void loop() {
    
  readTime();                                                                                    //Get time from RTC
  if(Current_Hour > 12){                                                                         //Put Alarm into 12 hour mode
    Current_Hour = Current_Hour - 12;
  }

  SetHour[Reed1_Loc] = digitalRead(Reed1);                                                       //Check states of Reed Contacts and buttons
  SetHour[Reed2_Loc] = digitalRead(Reed2);
  SetHour[Reed3_Loc] = digitalRead(Reed3);
  SetHour[Reed4_Loc] = digitalRead(Reed4);

  SetMinute[Reed5_Loc] = digitalRead(Reed5); 
  SetMinute[Reed6_Loc] = digitalRead(Reed6);
  SetMinute[Reed7_Loc] = digitalRead(Reed7);
  SetMinute[Reed8_Loc] = digitalRead(Reed8);
  SetMinute[Reed9_Loc] = digitalRead(Reed9);

  SwitchState = digitalRead(MicroSwitch);
  ButtonState = digitalRead(Button);

  Lampe();                                                                                     //Use Alarm as lamp if switch is pulled but no time set
  ActivateAlarm();                                                                             //Activate the alarm if time has been set
  Alarm();                                                                                     //When alarm is active, compare calculated target time with current time
  LightWaking();                                                                               //When Alarm() gives the go, start turning on the light
  SetTime();                                                                                   //Set time set on alarm as current time if switch is NOT pulled but time is set

}

//__________________________________________________________________
//______________FUNCTIONS___________________________________________
//__________________________________________________________________

byte decToBcd(byte val) {
  return ((val/10*16) + (val%10));
}
byte bcdToDec(byte val) {
  return ((val/16*10) + (val%16));
}

void PlayMelody(){
  digitalWrite(led, HIGH);                                                                 //LEDs are on while melody is playing
  for (int thisNote = 0; thisNote < 53; thisNote++) {                                      // iterate over the notes of the melody:.
    if(SwitchState != 0){                                                                  //only play melody as long as switch is pulled
      SwitchState = digitalRead(MicroSwitch);                                              //Refresh switch state
      int noteDuration = 1000 / noteDurations[thisNote];
      tone(speaker, melody[thisNote], noteDuration);
      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);
      noTone(8); 
    }
  }
}

void SetTime(){
  if (SwitchState == 0){                                                                   //check if switch is pulled
    if (memcmp( (const void *)notime, (const void*)SetMinute, sizeof(SetMinute)) != 0){    //check presence of input minute
      if (ButtonState == 0){                                                               //When button is pressed
        Wire.beginTransmission(DS1307);                                                    //Write time and date to RTC
        Wire.write(byte(0));
        Wire.write(second);
        Wire.write(decToBcd(Target_Minute));
        Wire.write(decToBcd(Target_Hour));
        Wire.write(weekday);
        Wire.write(monthday);
        Wire.write(month);
        Wire.write(year);
        Wire.write(byte(0));
        Wire.endTransmission();
        delay(250);
        fade(550, 200);
        }
    }
  }
  return;
}

void readTime() {                                                                          //Get current time from RTC
  Wire.beginTransmission(DS1307);
  Wire.write(byte(0));
  Wire.endTransmission();
  Wire.requestFrom(DS1307, 7);
  second = Wire.read();
  Current_Minute = bcdToDec(Wire.read());
  Current_Hour = bcdToDec(Wire.read());
  weekday = Wire.read();
  monthday = Wire.read();
  month = Wire.read();
  year = Wire.read();
}

void Alarm(){
  if (alarmactive == true){
    Target_Hour = GetHour();                                                              //Get the set Hour and Minute for the alarm
    Target_Minute = GetMinute();
    CalcWakeTime();                                                                       //Calculate at what time to wake
     if((Alarm_Hour == Current_Hour)&&(Alarm_Minute == Current_Minute)&&(waking==false)){ //Trigger Alarm Sequence once Hour and Minute matches waking time, only do this once
      waking = true;
      brightness = 0;
    }
  GiveTime();                                                                             //Blink time for confirmation
  }
  return;
}

void ActivateAlarm(){
  if (SwitchState != 0){                                                                  //check if switch is pulled
    if (memcmp( (const void *)notime, (const void*)SetMinute, sizeof(SetMinute)) != 0){   //check there is minute input
       alarmactive = true;
    }
    else{                                                                                 //Probably only Lamp
      alarmactive = false;
    }
  }
  else{
      alarmactive = false;
      waking = false;  
      blinktime = true;                                                                   //will tell set time after first turning alarm on
  }
  return;
}

void Lampe(){
  if (SwitchState != 0){                                                                  //check if switch is pulled
    if (memcmp( (const void *)notime, (const void*)SetMinute, sizeof(SetMinute)) == 0){   //check no input minute 
    if (memcmp( (const void *)five, (const void*)SetHour, sizeof(SetHour)) == 0){         //check no input hour
      analogWrite(led, brightnessLamp);
      if (brightnessLamp < 5){
        brightnessLamp = 155;
      }
        if (ButtonState != 1){
          if (brightnessLamp > 5){
            brightnessLamp = brightnessLamp - 50;                                                 //Reduce Brightness if button is pressed
            delay(750);
          }
          else{
            brightnessLamp = 255;                                                             //Go back to full brightness once limit has been reached
            delay(750);
          }
        }
    }
    }
    else{
      if((waking != true)&&(blinktime != true)){
        analogWrite(led, brightnessLamp);                                                     //turn light on
        if (ButtonState != 1){
          if (brightnessLamp != 0){
            brightnessLamp = brightnessLamp - 51;                                                 //Reduce Brightness if button is pressed
            delay(750);
          }
          else{
        brightnessLamp = 255;                                                               //Go back to full brightness once limit has been reached
        delay(750);
          }
        }
      }
    }
  }
  else{
    analogWrite(led, 0);                                                                //Always turn light off if Switch is not pulled
    brightnessLamp = 0;
  }
  return;
}

void LightWaking(){
  if (waking == true){                                                                  //only do if waking by light is on
    if ((brightness < 255)&&(SwitchState != 0)){                                        //Repeat as long as switch is pulled and brightness is not at max
      analogWrite(led, brightness);                                                     //turn light on
      unsigned long currentMillis = millis();
      if ((currentMillis - previousMillis >= first_interval)&&(fis != 0)){              //Start turning light on slowly
        previousMillis = currentMillis;
        brightness = brightness + 1;
        fis = fis - 1;
      }
      if ((currentMillis - previousMillis >= second_interval)&&(fis == 0)){             //Continue faster after 'first interval steps' amount of steps have passed
        previousMillis = currentMillis;
        brightness = brightness + 1;
      }
    }
    if ((brightness == 255)&&(SwitchState != 0)){                                        //Make noise when maximum brightness has been reached
      PlayMelody();
      analogWrite(led, brightness);
    }
  }
  else{
    fis = first_interval_steps;                                                           //define number of steps used for waking
  }
  return;
}

void CalcWakeTime(){
  Alarm_Minute = Target_Minute;
  Alarm_Hour = Target_Hour;
  for (int x = WakeTime; x > 0; x = x-1){
    Alarm_Minute = Alarm_Minute - 1;
    if(Alarm_Minute < 0){                                                               //Change hour if going below 0 Minutes
      Alarm_Minute = Alarm_Minute + 60;                                                 //Add 60 Minutes and remove 1 hour
      Alarm_Hour = Alarm_Hour -1;                                                     
    }
  }
  return;
}


void GiveTime(){
  if((blinktime==true)&&(alarmactive==true)){
    blinktime = false;                                                                   //make sure function only runs once
    for(int i=Target_Hour; i!=0; i=i-1){                                                 //Fade leds as many times as the hours that have been set
      if(SwitchState != 0){                                                              //Only blink time as long as switch is pulled
      fade(550, 10);
      SwitchState = digitalRead(MicroSwitch);                                            //Refresh switch state
      }
    }
    delay(500);                                                                         //wait short time between hours and minutes
    for(int i=Target_Minute/5; i!=0; i=i-1){                                            //Fade leds as many times as minutes that have been set devided by five
      if(SwitchState != 0){                                                             //Only blink time as long as switch is pulled
      SwitchState = digitalRead(MicroSwitch);                                           //Refresh switch state
      fade(550, 10);
      }
    }
  }
}

void fade(int BlinkTime,int maxbrigthness){
  int bri =0;
  int delaytime = BlinkTime/(2*maxbrigthness);
  for(int i=0; i<=maxbrigthness;i++){                                                   //increase brightness until maximum brightness has been reached
      analogWrite(led, bri);
      bri++;
      delay(delaytime);
  }

  for(int i=0; i<=maxbrigthness+1;i++){                                                 //decrease brightness until leds are off
      analogWrite(led, bri);
      bri=bri-1;
      delay(delaytime);
  }
}

int GetHour(){                                                                           //Function to return current set hour
    int i = 0;
if (memcmp( (const void *)twelve, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 12;
}
if (memcmp( (const void *)one, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 1;
  }
if (memcmp( (const void *)two, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 2;
  }
if (memcmp( (const void *)three, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 3;
  }
if (memcmp( (const void *)four, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 4;
  }
if (memcmp( (const void *)five, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 5;
  }
if (memcmp( (const void *)six, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 6;
  }
if (memcmp( (const void *)seven, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 7;
  }
if (memcmp( (const void *)eight, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 8;
  }
if (memcmp( (const void *)nine, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 9;
  }
if (memcmp( (const void *)ten, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 10;
  }
if (memcmp( (const void *)eleven, (const void*)SetHour, sizeof(SetHour)) == 0){
  i = 11;
  }
  return i;
}

int GetMinute(){                                                                            //function to return set minute
  int i = 69;
if (memcmp( (const void *)sixty, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 0;
}
if (memcmp( (const void *)sixty2, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 0;
}
if (memcmp( (const void *)zero_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 5;
  }
if (memcmp( (const void *)ten_z, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 10;
  }
if (memcmp( (const void *)ten_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 15;
  }
if (memcmp( (const void *)ten_f2, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 15;
  }
if (memcmp( (const void *)ten_f3, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 15;
  }
if (memcmp( (const void *)twenty_z, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 20;
  }
if (memcmp( (const void *)twenty_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 25;
  }
if (memcmp( (const void *)thirty_z, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 30;
  }
if (memcmp( (const void *)thirty_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 35;
  }
if (memcmp( (const void *)forty_z, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 40;
  }
if (memcmp( (const void *)forty_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 45;
  }
if (memcmp( (const void *)forty_f2, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 45;
  }
if (memcmp( (const void *)fifty_z, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 50;
  }
if (memcmp( (const void *)fifty_z2, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 50;
  }
if (memcmp( (const void *)fifty_f, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 55;
  }
if (memcmp( (const void *)notime, (const void*)SetMinute, sizeof(SetMinute)) == 0){
  i = 69;
}
return i;
}
